

//----------------------------------------------------------------------
//----------------------------------------------------------------------
//BNO085 read SUB--------------------------------------------------------
//-----------------------------------------------------------------------
//-----------------------------------------------------------------------
//----BNO085バイナリー整数変換---------------------------------------------
int  bin2int(uint8_t c0,uint8_t c1){
   int yawi=c0+c1*256;
      if(c1>=128){
        yawi=yawi-65535;
      }
      return yawi;
}
//-----------------------------------------------------------
int bnoread1(uint8_t *dBuf1,int n,int cnt)//1shotを受信して変換してdataで返す
//returnは、時刻 配列 d[]のポインタを渡されるので、*dがd番地の実数　nは、バイト数
{
  int bn85=0;//
  int t,t_1;
  int period[12];
 // uint8_t dBuf1[19],dB1[16];;
    if(Serial1.available()>19){  //19byte x12回でdBuf5満杯 
          //[0]0xaa,[1]0xaa,[2]index,[3]yawL,[4]yawM,[5]pitchL,[6]pitchM,[7]rollL,[8]roolM,[9]axL,[10]axM,[11]ayL,[12]ayM,[13]azL,[14]azM,[15]MI,[16]MR,[17]Rsv,[18]Chcksum
                  uint8_t  b0=Serial1.read();
                  uint8_t  b1=Serial1.read();
                  uint8_t  b2=Serial1.read();
                    t=micros();
                    if(b0==0xaa && b1==0xaa)
                    {
                      period[bn85%12]=t-t_1;
                      t_1=t;
                      int  n=(bn85%12)*19;//0-228
                        dBuf1[0+n]=b0;
                        dBuf1[1+n]=b1;
                        dBuf1[2+n]=b2;
                       //erial.printf("%db0=%x,b1=%x,",bn85%144,b0,b1);
                       int i;
                        //Serial.printf("Serial1 read:%x,%x,%x,",b0,b1,b2);
                        for(i=0;i<16;i++)//12byteずつ読み込み格納12x1
                        {
                            dBuf1[i+n+3]=Serial1.read(); 
                            //dB1[i]=dBuf1[i+n+3];       
                            //Serial.printf("%x,",dBuf1[i+n+3]);
                           //Serial.print(",");
                            //---------------------------
                            
                        }
                        //Serial.println();
                        /*
                        if(bn85%12==0)
                        {
                            data[0]=(float)(bin2int(dB1[0],dB1[1])*0.01);//yaw
                            data[1]=(float)(bin2int(dB1[2],dB1[3])*0.01);//pitch
                            data[2]=(float)(bin2int(dB1[4],dB1[5])*0.01);//roll
                            data[3]=(float)(bin2int(dB1[6],dB1[7])*0.01);//ax
                            data[4]=(float)(bin2int(dB1[8],dBuf1[9])*0.01);//ay
                            data[5]=(float)(bin2int(dBuf1[10],dBuf1[11])*0.01);//az
                            //Serial.printf("1,%4.3f,%4.3f,%4.3f,%4.3f,%4.3f,%4.3f,%d\n\r",data[0],data[1],data[2],data[3],data[4],data[5],millis());
                        }
                        */
                        //Serial.printf(":[%d]\n\r",millis());
                        bn85++;;   
                        cnt++;
                    }//0xaa && 0xaa end
    }//if serial available
    t=micros();
    return  cnt;
}//bnoread1 END
//OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
//-----------Serial3 Serial1同時READ-----------------------------------------------------------
//OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
int bnoread31(uint8_t *dBuf3,uint8_t *dBuf1,int n,int bncnt0){//1shotを受信して変換してdBuf1生データで返す
//returnは、時刻 配列 d[]のポインタを渡されるので、*dがd番地の実数　nは、バイト数
 
  String bnostr3;
  int bn85=0;//
  int t,t_1;
  int period[12];
  int cnt3=0;//Byte counter
  int cnt1=0;//Byte Counter
   
  
 // uint8_t dBuf3[19],dB3[16];;
    //Serial,printf("bnoread:Serail3=%d\n\r",Serial3.available());
    //Serial,printf("bnoread:Serail1=%d\n\r",Serial1.available());
    if(Serial3.available()>18){  //19byte x12回でdBuf5満杯 
          //[0]0xaa,[1]0xaa,[2]index,[3]yawL,[4]yawM,[5]pitchL,[6]pitchM,[7]rollL,[8]roolM,[9]axL,[10]axM,[11]ayL,[12]ayM,[13]azL,[14]azM,[15]MI,[16]MR,[17]Rsv,[18]Chcksum
                  uint8_t  b30=Serial3.read();
                  uint8_t  b31=Serial3.read();
                  uint8_t  b32=Serial3.read();
            
                    t=micros();
                    if(b30==0xaa && b31==0xaa )
                    {
                        dBuf3[0]=b30;
                        dBuf3[1]=b31;
                        dBuf3[2]=b32;
                        //Serial.printf("Serial3:%x,%x,%x,",b30,b31,b32);
                        //while(Serial3.available()>0){
                        while(cnt3<16){
                          if(Serial3.available()){
                              dBuf3[cnt3+3]=Serial3.read(); 
                              //Serial.print(dBuf3[cnt3+3],HEX);  
                              cnt3++;  
                              //Serial.printf("cnt3=%d,[%x],millis=%d\n\r",cnt3,dBuf3[cnt3+3],millis()); 
                          } 
                        } 
                        //Serial.println();
                         bncnt0++;
                    }//0xaa && 0xaa end
    }//END if serial3 available

     if(Serial1.available()>18){  //19byte x12回でdBuf5満杯 
          //[0]0xaa,[1]0xaa,[2]index,[3]yawL,[4]yawM,[5]pitchL,[6]pitchM,[7]rollL,[8]roolM,[9]axL,[10]axM,[11]ayL,[12]ayM,[13]azL,[14]azM,[15]MI,[16]MR,[17]Rsv,[18]Chcksum
                  uint8_t  b10=Serial1.read();
                  uint8_t  b11=Serial1.read();
                  uint8_t  b12=Serial1.read();
                  
                    t=micros();
                    if(b10==0xaa && b11==0xaa )
                    {
                        dBuf1[0]=b10;
                        dBuf1[1]=b11;
                        dBuf1[2]=b12;
                        //Serial.printf("Serial1:%x,%x,%x,",b10,b11,b12);
                        //while(Serial1.available()>0){
                        while(cnt1<16){
                          if(Serial1.available()){
                              dBuf1[cnt1+3]=Serial1.read(); 
                              //Serial.print(dBuf1[cnt1+3],HEX);  
                              cnt1++; 
                               //Serial.printf("cnt1=%d,[%x],millis=%d\n\r",cnt1,dBuf1[cnt1+3],millis());   
                          } 
                        } 
                        //Serial.println();
                        
                    }//0xaa && 0xaa end
              }//if serial available
    t=micros();
     
     
    return bncnt0;//累計EPOCH数
}//bnoread31 END
//OOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOOO
/*
//Srial3 READ-------------------------------------------------------------------------------------
int bnoread3(uint8_t *dBuf3,int n,int cnt)//1shotを受信して変換してdBuf1生データで返す
//returnは、時刻 配列 d[]のポインタを渡されるので、*dがd番地の実数　nは、バイト数
{
  String bnostr3;
  int bn85=0;//
  int t,t_1;
  int period[12];
  
 // uint8_t dBuf3[19],dB3[16];;
    if(Serial3.available()>19){  //19byte x12回でdBuf5満杯 
          //[0]0xaa,[1]0xaa,[2]index,[3]yawL,[4]yawM,[5]pitchL,[6]pitchM,[7]rollL,[8]roolM,[9]axL,[10]axM,[11]ayL,[12]ayM,[13]azL,[14]azM,[15]MI,[16]MR,[17]Rsv,[18]Chcksum
                  uint8_t  b0=Serial3.read();
                  uint8_t  b1=Serial3.read();
                  uint8_t  b2=Serial3.read();
                    t=micros();
                    if(b0==0xaa && b1==0xaa)
                    {
                      period[bn85%12]=t-t_1;
                      t_1=t;
                      int  n=(bn85%12)*19;//0-228
                        dBuf3[0+n]=b0;
                        dBuf3[1+n]=b1;
                        dBuf3[2+n]=b2;
                       //Serial.printf("%db0=%x,b1=%x,",bn85%144,b0,b1);
                       int i;
                        for(i=0;i<16;i++)//12byteずつ読み込み格納12x1
                        {
                            dBuf3[i+n+3]=Serial3.read(); 
                 
                        }
                        bn85++;;   
                        cnt++;
                        //Serial.printf("BNORead:cnt=%d,time=%d\n\r",cnt,millis());
                    }//0xaa && 0xaa end
    }//if serial available
    t=micros();
       
    return  cnt;
}//bnoread1 END
*/
//-----------------------------------------------------------------------
