//+++++++++++++4byte Binary to Long ++++++++++++++++++++++++++++++++++++++++++++++
long B2L(uint8_t b4 , uint8_t b3 , uint8_t b2 , uint8_t b1 )
{
  //pc.printf("B2L IN=%s,%x,%x,%x,%x,b4&0x80=%d\n\r",sen,b4,b3,b2,b1,b4 &0x80);
  //pc.printf("B2L IN=b4&0x80=%d\n\r",b4 & 0x80);
  long su;
  if (b4 & 0x80) { //最上位ビットたっていればマイナス
    //su = -(256 - (long)b1) + (255 - (long)b2) * 256 + (255 - (long)b3) * 65536 + (255 - (long)b4) * 256 * 256 * 256;
    //pc.printf("B2L-:sen=%s,%d,%d,%d,%d,%d\n\r",sen,b4,b3,b2,b1,su);
    uint32_t i1 = b1;
    uint32_t i2 = b2 << 8;
    uint32_t i3 = b3 << 16;
    uint32_t i4 = b4 << 24;
    uint32_t i5 = i1 | i2 | i3 | i4;
    su = (long)i5;

  }
  else {
    su = (long)b1 + (long)b2 * 256 + (long)b3 * 65536 + (long)b4 * 256 * 256 * 256;
    //pc.printf("B2L+:sen=%s,%d,%d,%d,%d,%d,%d\n\r",sen,b4,b3,b2,b1,su);
  }


  return su;
}
//=================================================================================
//+++++++++++++++i_to_char++++++++++++++++++++++++++++++++++++
// i=IntegerValueData,*d=Array pointer, n=Array start No
void  i_to_char(int i, uint8_t *d, int n)
{
  d[n] = i & 0x000000ff;
  d[n + 1] = (i & 0x0000ff00) >> 8;
  d[n + 2] = (i & 0x00ff0000) >> 16;
  d[n + 3] = (i & 0xff000000) >> 24;
 // Serial.printf("itochar:i=%d,d[0]=%x,d[1]=%x,d[2]=%x,d[3]=%x\n\r",i,d[0],d[1],d[2],d[3]);
}

//++++++++++++++++String to CharArray Trans++++++++++++++++++++
void str2char(char c[], String dataS)
{
  //String dataS;
  //dataS="HELLO dataS";
  int dataS_len = dataS.length() + 1;
 // char char_array[dataS_len];
  dataS.toCharArray(c, dataS_len);

}

//itow=> HH:MM:SS
String  itowToHMS(int itow) 
{
  String HMS;
  int DAY, HOUR, MIN, SEC, JHOUR;
  int DAY_MOD, HOUR_MOD, MIN_MOD;//, SEC_MOD;
  //DAY = int(itow / 86400000);
  DAY_MOD = itow % 86400000;
  HOUR = int(DAY_MOD / 3600000);
  HOUR_MOD = DAY_MOD % 3600000;
  MIN = int(HOUR_MOD / 60000);
  MIN_MOD = HOUR_MOD % 60000;
  SEC = int(MIN_MOD / 1000);
  //--UTC=>JST
  if (HOUR > 15) {
    JHOUR = HOUR + 9 - 24;
  }
  else {
    JHOUR = HOUR + 9;
  }
  //=====18sec 進んでいる？補正＝＝＝＝＝＝＝
  if (SEC < 18) {
    SEC = 60 - (18 - SEC);
  }
  else {
    SEC = SEC - 18;
  }
  //-------------
  //Serial.printf("itowToHMS:JHOUR=%d,MIN=%d,SEC=%d\n\r",JHOUR,MIN,SEC);
  HMS = String(JHOUR) + ":" + String(MIN) + ":" + String(SEC);
  return HMS;

}//itowToHMS end=
//===========================================================================================
void basesort(int dN,int stPVTN,uint8_t *dBuf4P,uint8_t *dBuf4)
{
 //******************生データをソートする場所で２分割表示***************************::
  //Serial.println();
 // Serial.printf("********************SourceData dBuf4[] CHECK dN=%d,stPVTN=%d*******************************:\n\r",dN,stPVTN);
  int x=0;//普段は使わない
  int i,j;
  if(x==1)
  {
    for(i=0;i<dN;i++)
    {
        if(i<stPVTN)
        {
          //Serial.print(dBuf4[i],HEX);
        //Serial.print(",");
        }
        else if(i==stPVTN)
        {
          //Serial.println();
          //Serial.print("HEADER=>,");
        //Serial.print(dBuf4[i],HEX);
          //Serial.print(",");
        }
    
        else if(i>stPVTN)
        {
          //Serial.print(dBuf4[i],HEX);
          //Serial.print(",");
        }
    }
  }

  //===Base SORT処理開始========================================================
  //Serial.println();
  //Serial.printf("----------------------BaseSORTing＝＞SORT dBuf4=>dBuf4P dN=%d stPVTN=%d-------------------------------------\n\r",dN,stPVTN);
  //Serial.print(" dBuf4:");
      j=stPVTN;
      int PVT1startNo = j;
      //Serial.printf("PVT1startNo=%d\n\r",PVT1startNo);
  //Sorting--------------------------------------------------------------------------------
  int jj;
  for (jj = 0; jj <dN - PVT1startNo; jj++) //後半部Sort dBuf4[PVT1startNo]～dBuf4[dN-1]　To dBuf14[0]～dBuf4[dN-1-PVT1startNo]
  {
    dBuf4P[jj] = dBuf4[PVT1startNo + jj];//ヘッダーのある位置からよみとって、新しい配列dBuf4Pに代入して、データの最後までdN-PVT1startNo　個コピー
    if(jj<6){
      //Serial.printf("dBuf4P[%d]=%x\n\r", jj,dBuf4P[jj]);
    }
    if(jj>dN- PVT1startNo-6){
      //Serial.println();
      //Serial.printf("dBuf4P[%d]=%x\n\r",jj,dBuf4P[jj]);
    }
  }
  for (jj = 0; jj < PVT1startNo; jj++) //先頭部ソート
  {
    dBuf4P[jj + dN- PVT1startNo] = dBuf4[jj];
    //Serial.printf("dBuf4P[%d]=%x,",jj+dN-PVT1startNo,dBuf4[jj]);
    if(jj<6){
      //Serial.printf("dBuf4P[%d]=%x\n\r",jj + dN- PVT1startNo,dBuf4[jj]);
    }
    if(jj>PVT1startNo-6){
      //Serial.println();
      //Serial.printf("dBuf4P[%d]=%x\n\r",jj + dN- PVT1startNo,dBuf4[jj]);
    }
  }
   //Serial.println("===================SORTED:dBuf4P:======================================");
   for(j=0;j<dN;j++)
   {
      //Serial.print(dBuf4P[j],HEX);
      //Serial.print(",");
      dBuf4[i]=0;//dBuf4クリア
   }
  
}

//+++PVTcnv++++++++++++++++++++++++++++++++++++++++++++++++++++++
int PVTcnv(uint8_t d[100], long pvt[33]) 
{
  //PVT header[0-6]
  //0:itow[6-9]
  pvt[0] = B2L(d[9], d[8], d[7], d[6]);
  //Serial.printf("PVTcnv:itow=%d\n\r",pvt[0]);
  //1:year[10-12]
  pvt[1] = (long)d[10] + d[11] * 256;
  //2:month[12]
  pvt[2] = (long)d[12];
  //3:day[13]
  pvt[3] = (long)d[13];
  //4:hour[14]
  pvt[4] = (long)d[14];
  //Serial.printf("PVTcnv:hour=%d\n\r",pvt[4]);
  //5:min[15]
  pvt[5] = (long)d[15];
  //Serial.printf("PVTcnv:min=%d\n\r",pvt[5]);
  //6:sec[16]
  pvt[6] = (long)d[16];
  //Serial.printf("PVTcnv:sec=%d\n\r",pvt[6]);
  //7:valid[17]
  pvt[7] = (long)d[17];
  //8:tAcc[18-21]
  pvt[8] = B2L(d[21], d[20], d[19], d[18]);
  //9:nano[22-25]
  pvt[9] = B2L(d[25], d[24], d[23], d[22]);
  //10:fixType[26]
  pvt[10] = (long) d[26];
  //11:flags[27] This is Fix status 131
  pvt[11] = (long)d[27];
  //12:flags2[28]
  pvt[12] = (long)d[28];
  //13:numSV[29]
  pvt[13] = (long)d[29];
  //14:lon[30-33]
  pvt[14] = B2L(d[33], d[32], d[31], d[30]);
  //15:lat[34-37]
  pvt[15] = B2L(d[37], d[36], d[35], d[34]);
  //16:height[38-41]
  pvt[16] = B2L(d[41], d[40], d[39], d[38]);
  //17:hMSL[42-45]
  pvt[17] = B2L(d[45], d[44], d[43], d[42]);
  //18:hAcc[46-49]
  pvt[18] = B2L(d[49], d[48], d[47], d[46]);
  //19:vAcc[50-53]
  pvt[19] = B2L(d[53], d[52], d[51], d[50]);
  //20:velN[54-57]
  pvt[20] = B2L(d[57], d[56], d[55], d[54]);
  //21:velE[58-61]
  pvt[21] = B2L(d[61], d[60], d[59], d[58]);
  //22:velD[62-65]
  pvt[22] = B2L(d[65], d[64], d[63], d[62]);
  //23:gSpeed[66-69]
  pvt[23] = B2L(d[69], d[68], d[67], d[66]);
  //24:headMot[70-73]
  pvt[24] = B2L(d[73], d[72], d[71], d[70]);

  //25:sAcc[74-77]
  pvt[25] = B2L(d[77], d[76], d[75], d[74]);
  //26:headAcc[78-81]
  pvt[26] = B2L(d[81], d[80], d[79], d[78]);
  //27:pDOP[82-83]
  pvt[27] = (long)d[82] + d[83] * 256;
  //28:flags3[84]
  pvt[28] = (long)d[84];
  //29:reserved1[85]
  pvt[29] = (long)d[85];
  //30:headVeh[86-89]
  pvt[30] = B2L(d[89], d[88], d[87], d[86]);
  //31:magDec[90-91]
  pvt[31] = (long)d[90] + d[91] * 256;
  //32:magAcc[92-93]
  pvt[32] = (long)d[92] + d[93] * 256;

  return (int)pvt[0];
}//PVTcnv() end
//--RELPOScnv++++++++++++++++++++++++++++++++++++++++++++++++++++++
int RELPOScnv(uint8_t d[72], long relpos[20]) 
{
  //RELPOS header[0-5]
  int s = 0;
  //0:ver[6]
  relpos[0] = (long)d[s + 6];
  //1:reserved1[7]
  relpos[1] = (long) d[s + 7];
  //2:refStationId[8-9]
  relpos[2] = (long)d[s + 8];
  //3:itow[10-13]
  relpos[3] = (long)B2L(d[s + 13], d[s + 12], d[s + 11], d[s + 10]);
  //Serial.printf("RELPOScnv:itow=%d\n\r",relpos[3]);
  //4:relposN[14-17]
  relpos[4] = B2L(d[s + 17], d[s + 16], d[s + 15], d[s + 14]);
  //5:relposE[18-21]
  relpos[5] = B2L(d[s + 21], d[s + 20], d[s + 19], d[s + 18]);
  //6:relposD[22-25]
  relpos[6] = B2L(d[s + 25], d[s + 24], d[s + 23], d[s + 22]);
  //7:relposLength[26-29]
  relpos[7] = B2L(d[s + 29], d[s + 28], d[s + 27], d[s + 26]);
  //Serial.printf("RELPOScnv:Lenghth=relpos[7]=%d\n\r",relpos[7]);
  //8:relposHeading[30-33]
  relpos[8] = B2L(d[s + 33], d[s + 32], d[s + 31], d[s + 30]);
  //Serial.printf("relposHeading[8]=%d,[33]%x,[32]%x,[31]%x,[30]%x,\n\r",relpos[8],d[33],d[32],d[31],d[30]);
  //9:reserved2[34]
  relpos[9] = B2L(d[s + 37], d[s + 36], d[s + 35], d[s + 34]);
  //10:relposHPN[35]
  relpos[10] = (long)((d[s + 38] & 127) - (d[s + 38]& 128));
  //Serial.printf("HPN=%d,d[38]=%x,d[39]=%x,d[40]=%x,d[41]=%x,&127=%dx,&128=%d\n\r",relpos[10],d[38],d[39],d[40],d[41],d[38] && 127,d[38] && 128);
  //11:relposHPE[36]
  relpos[11] = (long)((d[s + 39] & 127) - (d[s + 39] & 128));
  //12:relposHPD[37]
  relpos[12] = (long)((d[s + 40] & 127) - (d[s + 40] & 128));
  //13:relposHPLength[38]
  relpos[13] = (long)((d[s + 41] & 127) - (d[s + 41] & 128));
  //14:accN[38-41]
  relpos[14] = B2L(d[s + 41], d[s + 40], d[s + 39], d[s + 38]);
  //15:accE[42-45]
  relpos[15] = B2L(d[s + 45], d[s + 44], d[s + 43], d[s + 42]);
  //16:accD[46-49]
  relpos[16] = B2L(d[s + 49], d[s + 48], d[s + 47], d[s + 46]);
  //17:accLength[50-53]
  relpos[17] = B2L(d[s + 53], d[s + 52], d[s + 51], d[s + 50]);
  //18:accHeading[54-57]
  relpos[18] = B2L(d[s + 57], d[s + 56], d[s + 55], d[s + 54]);
  //19:reserved[57-60]
  relpos[19] = B2L(d[s + 61], d[s + 60], d[s + 59], d[s + 58]);
  //20:flags[60-63]
  relpos[20] = B2L(d[s + 65], d[s + 64], d[s + 63], d[s + 62]);

  return (int)relpos[3];
}
