//STA25   Base SAT Rcieve Test & SDIO LOG  2025/1/11
//08はloop直下で他の処理殺して動作OK
//081は、ソート処理を後処理へ移動、受信のみloop直下
//084　バッファ768で動作OK　しかしバグ
//0841  バッファ１０２４に戻すやはり　OPENERRORがでた
//0842  768に戻すしかしOpen errorでた084でOKしてから再度0842OKだったN＝３回起動テスト全OKだった
//0843  dBuf4[]を変換後にゼロリセット追加 N1OK
//085   Filenameで日付ファイル名に変更OK
//0851  実データwrite
//0852  シリアルバッファ動作解析=>満杯の場合は置いたまま後処理に行くのでrelposを置いてしまうからダメ
//0853  sdwrite４で受信直後にdBuf4をdN分だけ保存してつなぎ目でおちをなくす。
//0853rev00 BNO追加　ファイルタブ分割Ok
//0853 rev01  BNO SDがうまくいかないASCIIだと変だ
//0853 rev02  BNO binaryでカウント４バイト＋１９バイト＝２３バイト/10msecで HWBを960バイトまで拡大OKログOK
//0853 rev03  BNOトップ Serial1とSerial3別関数だと同期とれてないから１関数内で２つ受信にする
//0853 rev04  １関数内２つ受信して同期を確保OK
//0853 rev05  BNO SD write OK
//0853 rev06  基板ADS線延長。Roverコネクタ追加 ads bno同期ＳＤログｏｋ　BAXXX.bin ファイル保存　header 0xFF bnocnt0(4byte)data1chi(4byte)data2chi(4byte)0xaa0xaa....0xaa0xaa..
 
#include "BNO.h"
#include "Base.h"
#include "SdFat.h"
#define SD_CONFIG SdioConfig(FIFO_SDIO)
// SdFat-beta usage
SdFs sd;
FsFile myFile;
FsFile myFileB;//Base FILE
FsFile myFileI;//IMU FILE
FsFile dir;
FsFile file;
#define error(s) sd.errorHalt(&Serial, F(s))

//---------SD parameters---------------
//String fnameI="test.csv";
static int startime,sdflag;
static int dcount,dcount_1;
//FileNames
static int fnflag;//1回だけ使う0=>1
 int JST_day;
//timestamp file name
volatile static uint8_t Sflag = 0;
uint8_t logflag=0;
static char fnameB[30];//UBX Binary File name
char fnameR[30];//Rover Binary
char fnameM[30];//UBX Value File name NAV-PVT+NAV-RELPOSNED
char fnameI[30];//imu TXT
char fnameAv[30];//averaging File
char monC[200];//Monitor Text data Save
int chk;
//--------Base Parameters-------------------------------------
static uint8_t serialbuffer4[960];//staticにしないとsdFatとぶつかる
static uint8_t dBuf4[1024],dBuf4P[1024],dBuf4V[100],dBuf4R[72],dBuf4S[1024];
static int i,n,j;
static int dN,stPVTN,stRELN,stSATN;
uint8_t d0,d1,d2,d3,d4;//B5,62,01,07,5c
static int  toptime,rcvtime,rcvtime_1;
static int ts,te,tw0,tw1,tw2,tp0,tp1,tp2;
static int  pvtpos,relpos,satpos;
//ubx
static long itowpvt,itowsat,itowrelp;
static long pvt[33],relp[20];
void basesort(int dn,int stPVTN);
//--SATTELLITE  Parameters
static int  numSV,messize,paykoadsize;
static uint8_t gnssid[100];
static uint8_t satid[100];
static int cno[100];
static int elevation[100];
static int azimath[100];
static int upper40[100],n40;//40dB以上の衛星配列番号記録
static int upper50[100],n50;//50dB以上の衛星配列番号記録
static int  flags,numSVr;
static double hacc;
//-----BNO085  parameter definitions-----------------------
static uint8_t serialbuffer1[32];//バッファは、static変数配列で宣言しておく。32byteの倍数で確保すること
static uint8_t serialbuffer3[32];//バッファは、static変数配列で宣言しておく。32byteの倍数で確保すること
static uint8_t  dBuf1[19];
static uint8_t  dBuf3[19];
static uint8_t dB1[19];
static uint8_t dB3[19];
static uint8_t dB1_1,dB3_1;//１個前のIndex
volatile static int bn85=0;
int iij;
float yawf[12],pitchf[12],rollf[12];
float axf[12],ayf[12],azf[12];
//uint8_t c[300];
static int p1,p1_1;
static int p3,p3_1;
static int period[12];
static String bnostr3,bnostr1;//bnoreadで
static String bnostr312;//12個まとめた文字列 ヘッダにシリアル番号３
static String bnostr112;//12個まとめた文字列ヘッダにシリアル番号１
static uint32_t bncnt0,bncnt0_1,bncnt01;//serial3　Serial1の合計数
//----------------Texsus ADS122U04--------------------------
static int  DRDY = 23; //DataRdy Pin 23
static int DRDY_1;
//NGstatic long ft1, ft2,ft3,ts,ts_1,ts_10;//,period;
int  RREGwait;
static int pt0,pt0_1;
static int flipN,endflip;
static uint8_t RR0, RR1, RR2, RR3, RR4;
static uint8_t ad0, ad1, ad2, ad3, ad4, ad5, ad6;
static long data1chi, data2chi;
static double data1ch, data2ch;
static int ats,ats_1,ats_10;
int  DRDYflag = 0;
int res;
int  cd=0;
static int flipt0,flipt1,ft1,ft2,periodt;
//ADS122 InterruptIn DRDY====================
void flip() 
{
  flipN++;
  //Serial.printf("flipN=%d\n\r",flipN);
  flipt0=micros();
  ats=micros();
  //delayMicroseconds(100000);
  if (flipN % 2 == 0 )//偶数回は１CH,奇数回は2CH　Ch間ずれ1.4msec  周期2.65msec 370Hz
  {
    //1CH-----Register00[7:4(MUX)3:1(GAIN)0(PGA_BYPASS)]--------------------------------------------------------------
    Serial5.write(0x55);//Synchronization word 0x55
    Serial5.write(0x40);//WriteREGister 0x04 0x00(0000register00 Selected)
    Serial5.write(0x0E);//7:0(0000 1110=0x0E)[7:4(0000)MUX AINp=AIN0,AINn=AIN1 3:1(111)GAIN128, 0:0(0)PGA enabled]
    //Serial5.write(0x0C);//7:0(0000 1100=0x0c)[7:4(0000)MUX AINp=AIN0,AINn=AIN1 3:1(110)GAIN64, 0:0(0)PGA enabled]
    delayMicroseconds(50);
    Serial5.write(0x55);
    delayMicroseconds(cd);
    Serial5.write(0x10);
    delayMicroseconds(10);
    ad0 = Serial5.read();
    delayMicroseconds(10);
    ad1 = Serial5.read();
    delayMicroseconds(10);
    ad2 = Serial5.read();
    delayMicroseconds(10);
   
    data1chi=Toint24(ad0,ad1,ad2);
    //Serial.printf("[CH1]%d:d0=%x,d1=%x,d2=%x,data=%d\n\r",millis(),d0,d1,d2,data1chi);
    ft1 = (int)(micros());
    endflip=0;
     //Serial.printf("%d,%6.2f\n\r",data1chi,ft1);
  }
  else 
  {
    //2CH-----Register00[7:4(MUX)3:1(GAIN)0(PGA_BYPASS)]--------------------------------------------------------------
    delayMicroseconds(50);
    Serial5.write(0x55);//Synchronization word 0x55
    delayMicroseconds(cd);
    Serial5.write(0x40);//WriteREGister 0x04 0x00(0000register00 Selected)
    delayMicroseconds(cd);
    Serial5.write(0x6E);//7:0(0110 1110=0x6E)[7:4(0110)MUX AINp=AIN2,AINn=AIN3 3:1(111)GAIN128, 0:0(0)PGA enabled]
    //Serial5.write(0x60);//7:0(0110 0000=0x60)[7:4(0110)MUX AINp=AIN2,AINn=AIN3 3:1(000)GAIN1, 0:0(0)PGA enabled]
    delayMicroseconds(100);

    Serial5.write(0x55);
    delayMicroseconds(cd);
    Serial5.write(0x10);
    delayMicroseconds(10);
    ad3 = Serial5.read();
    delayMicroseconds(10);
    ad4 = Serial5.read();
    delayMicroseconds(10);
    ad5 = Serial5.read();
    delayMicroseconds(10);
    data2chi=Toint24(ad3,ad4,ad5);
    //Serial.printf("[CH2]%d:d3=%x,d4=%x,d5=%x,data=%d\n\r",millis(),d3,d4,d5,data2chi);
    ft2 = (int)(micros());
    int ft3=int(micros())-ats;    
    periodt=ats-ats_1;
    ats_1=ats;
    endflip=1;
    //Serial.printf("%d,%d,%d,%d,%d,%d\n\r",flipN,data1chi,data2chi,ft1,ft2,ft3);
    //if(ts-ts_10>10000)
    //{
      //Serial.printf("%d,%d,%d,%d,%d,%d\n\r",flipN,data1chi,data2chi,ats,period,ats-ats_10);
      //Serial.printf("%d,%d,%d,%d\n\r",flipN,data1chi,data2chi,periodt);
      ats_10=ats;
    //}
    
    
  
  }
   flipt1=micros();
}
//ADS122 flip END===================================
//-----------ADS122U04  Initialize-------------
void adsinit()
{
  int cd=0;
  Serial.println("ADS INIT IN");
   //=============ADS122U04レジスタ初期設定==========================================
  //ADS122U04 RESET
     Serial5.write(0x55);
     delayMicroseconds(cd);
     Serial5.write(0x06);
      delayMicroseconds(1000);

   int  res= readReg(0);
  //================Register Setting=============================================================================
  RREGwait = 1000; //RREG wait time usec 2*Tbaud(10usec)
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                    
  //-----Register00[7:4(MUX)3:1(GAIN)0(PGA_BYPASS)]--------------------------------------------------------------
  Serial.println("Register0 writing");
  Serial5.write(0x55);//Synchronization word 0x55
  delayMicroseconds(cd);
  Serial5.write(0x40);//WriteREGister 0x04 0x00(0000register00 Selected)
   delayMicroseconds(cd);
  //Serial5.write(0x0E);//7:0(0000 1110=0x0E)[7:4(0000)MUX AINp=AIN0,AINn=AIN1 3:1(111)GAIN128, 0:0(0)PGA enabled]
  Serial5.write(0x0C);//7:0(0000 1100=0x0C)[7:4(0000)MUX AINp=AIN0,AINn=AIN1 3:1(110)GAIN64, 0:0(0)PGA enabled]

  delayMicroseconds(1000);
  
  res=readReg(0);
  
  //-----Register01[7:5(DataRate)4:(OperationMode)3:(ConversionMode)2:1(VREF)0:(TemperatureSensor mode)]---------
  Serial.println("Register1 writing");
  Serial5.write(0x55);//Synchronization word 0x55
  delayMicroseconds(cd);
  Serial5.write(0x42);// WriteREGister 0x04 0x02(0010register01 Selected)
  delayMicroseconds(cd);
  Serial5.write(0xCE);//7:0(1100 1110=0xCE)[7:5(110)DataRate1000sps,4:(0)Normal Mode, 3:(1)Continuous conversion mode,2:1(11)VDD-VSS VRef,0:(0)Temp disabled]
  //Serial5.write(0xAE);//7:0(1010 1110=0xAE)[7:5(101)DataRate600sps,4:(0)Normal Mode, 3:(1)Continuous conversion mode,2:1(11)VDD-VSS VRef,0:(0)Temp disabled]
  //Serial5.write(0x8E);//7:0(1000 1110=0x8E)[7:5(100)DataRate330sps,4:(0)Normal Mode, 3:(1)Continuous conversion mode,2:1(11)VDD-VSS VRef,0:(0)Temp disabled]
  //Serial5.write(0x4E);//7:0(0100 1110=0x0E)[7:5(010)DataRate90sps,4:(0)Normal Mode, 3:(1)Continuous conversion mode,2:1(11)VDD-VSS VRef,0:(0)Temp disabled]

  delayMicroseconds(1000);

  res=readReg(1);

  //-----Register02[7:DRDY)6:(DCNT)5:4(CRC)3:(BCS)2:0(IDAC)]-----------------------------------------------------
  Serial.println("Register2 writing");
  Serial5.write(0x55);//Synchronization word 0x55
  delayMicroseconds(cd);
  Serial5.write(0x44);// WriteREGister 0x04 0x04(0100register02 Selected)
  delayMicroseconds(cd);
  Serial5.write(0x00);//7:0(0000 1000=0x08)[7:(0)DRDY,6:(0)DCNT disable, 5:4(00)) inverte,3:(1)BCS Off（0）,2:0(0)IDAC off]
  delayMicroseconds(1000);
  
  res=readReg(2);

  //----Register03[7:5(I1MUX)4:2(I2MUX)1(RSERVED)0(AUTO)]----------------------------------------------------
  Serial.println("Register3 writing");
  Serial5.write(0x55);//Synchronization word 0x55
  delayMicroseconds(cd);
  Serial5.write(0x46);// WriteREGister 0x04 0x06(0110register03 Selected)
  delayMicroseconds(cd);
  Serial5.write(0x00);//7:0(00000000=0x00)[7:5(000)default,4:2(000)default, 1:(0)Reserved,0:(0)Manual Read
  delayMicroseconds(1000);
  
  res=readReg(3);

  delayMicroseconds(1000);
  //----Register04[7:(Reserved)6:(GPIO2DIR)5:(GPIO1DIR)4:(GPIO0DIR)3:(GPIO2SEL)2:(GPIO2DAT)1:(GPIO1DAT)0:(GPIODAT0)]----------------------------------------------------
  Serial.println("Register4 writing");
  Serial5.write(0x55);//Synchronization word 0x55
  delayMicroseconds(cd);
  Serial5.write(0x48);// WriteREGister 0x04 0x08(1000register04 Selected)
  delayMicroseconds(cd);
  Serial5.write(0x48);//7:0(0100 1000=0x08)[6:(1)GPIO2output,5:(0)GPIO1Input, 4:(0)GPIO0Input,3:(1)GPIO2SEL DRDY,2:(0)GPIO2DAT Low,1:(0)GPIO1DAT Low,0:(0)GPIO0DAT Low
  delayMicroseconds(1000);
  
  res=readReg(4);
  Serial.println("CHECK Written Registers");
  delay(5000);

  //Start/Sync
  Serial5.write(0x55);
  delayMicroseconds(cd);
  Serial5.write(0x08);
   delayMicroseconds(100);//************************このWAIT重要************************************
  
  

}
//--------------toint32-----------------------------
int Toint24(byte d0, byte d1, byte d2)
{
      
    long val;
    if ((d2 & B10000000) == B10000000)
    { //最上位ビットたっていればマイナス
       val=(d0+d1*256+d2*256*256)-0xFFFFFF+1;
    }
    else
    {
       val = d0+d1*256+d2*256*256;
       
    }
    return val;
}



//関数--------------------------------------------------
int readReg(int n)
{
   //Serial.println("In readReg");
   int RREGwait=600;
   int regN=0;
   int RR;
   if(n==0){regN=0x20;}
   if(n==1){regN=0x22;}
   if(n==2){regN=0x24;}
   if(n==3){regN=0x26;}
   if(n==4){regN=0x28;}
   Serial5.write(0x55);//Synchronization word 0x55
   delayMicroseconds(cd);
   Serial5.write(regN);//Synchronization word 0x55 Read REGister00=0010 0000=0x20
   delayMicroseconds(RREGwait);
   int flag=0;
   while (flag==0)
   {
        if(Serial5.available())
            {
               RR = Serial5.read();
               delayMicroseconds(RREGwait);
               //Serial.printf("readRegister%x=>[0x%x]",n,RR);
               //Serial.println();
               flag=1;
          }
  }
  //Serial5.clear();
  return RR;
}
//ADS122 functions END==================================
//Base Recieve
int basercv()
{
   int bufcnt=0;
if(Serial4.available()>300)//Serial4から一挙に受信
   {
          i=0;
         
          rcvtime_1=rcvtime;
          rcvtime=millis();
          while(Serial4.available()>0)
          {
            if(Serial4.available())//readの直前にSerial.available()を入れないとバグる
            {
              dBuf4[i+4]=Serial4.read();
              i++;
            }
            bufcnt++;
          }
          dN=i;//受信データ数
          dcount++;
          //Serial.printf("RECIEVED,dN=,%d ,toptime=%d,recvtime-rcvtime_1=%d\n\r",dN,toptime,rcvtime-rcvtime_1);
          //Serial.printf("==================recieved dN=%d,bufcnt=%d\n\r",dN,bufcnt);
  }//if 172> serial
  else{
    Serial.printf("NOT Serial3.available：Else time=%d\n\r",millis());
  }
  return dN;
}
//============SD関数=========================================================================

void  sdinit()
{
   if (!sd.begin(SD_CONFIG)) {
      Serial.println("SD CARD initialization failed!");
       
      return;
    }
    Serial.println("SD initialization done.");
     /*
    myFileI = sd.open("test01.txt", FILE_WRITE); 
     if(!myFileI)
     {
        Serial.println("=============myFileI Open Error============");
         
        exit(0);
     }
      else
      {
        Serial.println("==============myFileI Open Successed=========");
         
      }
      */
    
}
int sdwrite(int dcount)//dBuf４を保存
{
     int c;
     //==========================================================================================================
        //=================OPEN CLOSE R=========================================================================
        //=========================================================================================================
        //if(millis()%20000<=>0 )//30secに一回close open
        //dcount++;
        if(dcount%500==0)//60sec
          {
            //dcount=0;
            
              myFile.close();
              myFileI.close();
              delay(15);//このWAIT重要close  open間
            
            
            myFile = sd.open(fnameB, FILE_WRITE);
            if(!myFile){
              //Serial.println("************myFIleB timer OPEN ERROR*******************");
              c=1;
            }       
            if(!myFile){
              //Serial.println("************myFIleB timer OPEN ERROR*******************");
              c=1;
            }
            else{
              Serial.printf("myFileB Close&Open t=%d*******************\n\r",millis());
            }
            //myFileI OPEN
            myFileI =sd.open(fnameI, FILE_WRITE);
            if(!myFileI){
              //Serial.println("************myFIleI timer OPEN ERROR*******************");
              //c=1;
            }
            else{
              Serial.printf("****myFileI Close&Open t=%d*****************\n\r",millis());
            }

            
            //for(i=0;i<dN;i++)
              //{
                //if(myFile)
                //{
                  //myFile.write(dBuf4P[i]);
                  //Serial.print("*");
                //}
                //else
                //{
                  //Serial.print("x");
                //}
              //}

        }     
        //1回OPEN
        
         //=================SD LOG===========================
          delay(5);
         
          if(!myFile)
            {
                //Serial.printf("=============myFile open Error============%d\n\r",dcount);
                c=2;
                //exit(0);
            }
            else
            {
              //Serial.println("==============myFile Write Successed=========");
               ts=micros();
              for(i=0;i<dN;i++)
              {
                if(myFile){
                  myFile.write(dBuf4[i]);
                }
              }
               te=micros();
              c=0;
            }
         
        //SD LOG END
        return c;//c=0 OK  c=1 OPEN error  c=2 write error
}
 void sdlist()
 {
   int ci=0;//file couter
  // Open root directory 
  if (!dir.open("/")){
    error("dir.open failed");
  }
  // Open next file in root.
  // Warning, openNext starts at the current position of dir so a
  // rewind may be necessary in your application.
  while (file.openNext(&dir, O_RDONLY)) {
    ci++;
    file.printFileSize(&Serial);
    delay(1);
     //file.printFileSize(&Serial2);
    Serial.write(' ');
    //Serial2.write(' ');
    file.printModifyDateTime(&Serial);
    delay(1);
     //file.printModifyDateTime(&Serial2);
    Serial.write(' ');
    delay(1);
    //Serial2.write(' ');
    file.printName(&Serial);
    delay(1);
    //file.printName(&Serial2);
    if (file.isDir()) {
      // Indicate a directory.
      Serial.write('/');
      //Serial2.write('/');
    }
    Serial.println();
     //Serial2.println();
    file.close();
  }
  if (dir.getError()) {
    Serial.println("openNext failed");
  } else {
    Serial.println("Done!");
  }
 }
 //+++++++++++++++++++++++++++++++++
 void doReboot() 
 {
  Serial.println("#####################DO REBOOT##############");
  SCB_AIRCR = 0x05FA0004;
 }
void Filename (long *PVT) 
{//ファイル名をタイムスタンプ
  //if (PVTBval[11] == 131 && Sflag == 0) { //start
  //---PVTBval[1]=Year/[2]=Month/[3]=Day/[4]=Hour/[5]=Min/[6]=sec---
 
  int JST = (PVT[4] + 9) % 24; //UTC hourをJSTに変換
  if (JST < 9) { //UTCが０時以前の場合日付を日本日付に修正
    JST_day = 1;
  }
  else {
    JST_day = 0;
  }
  String  stime = String(PVT[2], DEC) + "-" + String(PVT[3] + JST_day, DEC) + "-" + String(JST, DEC) + "-" + String(PVT[5], DEC); //MMDDHHMM
  String stimeB = "base_"+stime + ".ubx"; //UBX Binary File
  String stimeAv="Ave"+ stime + ".txt"; //Averaging txt File
  String stimeI="BA_"+stime+".bin";//BNO data binary File
  int slenB = stimeB.length() + 1;
  int slenAv=stimeAv.length()+1;
  int slenI=stimeI.length()+1;
  //ファイル名はchar配列なのでStringからchar配列変換　fname[]を得る
  stimeB.toCharArray(fnameB, slenB); //stimeB to fnameB[] chara Array
  stimeAv.toCharArray(fnameAv, slenAv); //stimeAv to fnameAv[] chara Array
  stimeI.toCharArray(fnameI,slenI);//stimeI to fnameI[] char Array

  Serial.print("fnameB=");
  Serial.println(stimeB);
  Serial.print("fnameAv=");
  Serial.println(stimeAv);
  Serial.print("fanemI=");
  Serial.println(stimeI);
  delay(10);
}//Filename() end 
//-----------------------------------------------------------

void setup() 
{
  Serial.begin(460800);
  
  Serial1.begin(115200);//Tail BNO085 RVC MODE pin0 Tx In
  //Serial1.addMemoryForRead(serialbuffer1, sizeof(serialbuffer1));//serialbuffer1のメモリーを 256byteバッファ指定
  Serial3.begin(115200);//Center BNO085 RVC MODE pin15 TX In
  //Serial3.addMemoryForRead(serialbuffer1, sizeof(serialbuffer1));//serialbuffer1のメモリーを 256byteバッファ指定
  Serial5.begin(115200); //Teensy4.1 RX5-ADS122 RX5(21)-TX,TX5(20)-RX
  Serial4.begin(115200);//Base
  Serial4.addMemoryForRead(serialbuffer4, sizeof(serialbuffer4));
  delay(10000);
  adsinit();
  pinMode(DRDY, INPUT_PULLUP);
  //attachInterrupt(digitalPinToInterrupt(2),呼び出される関数,FALLING);
  attachInterrupt(DRDY, flip,FALLING);//DRDY 下がりエッジで割り込み関数flipへ飛ぶ

  if (!sd.begin(SD_CONFIG)) {
    Serial.println("initialization failed!");
    return;
  }
  Serial.println("initialization done.");
  delay(100);
  
  // 1st test OPEN
   myFileB = sd.open("fname00.ubx", FILE_WRITE); 
     if(!myFileB)
     {
        Serial.println("=============myFileB 1st Open Error============");
       
        exit(0);
     }
      else
      {
        Serial.println("==============myFileB 1st Open Successed=========");
        for(i=0;i<100;i++)
        {
           if(myFileB){
            myFileB.write(0x0A);
           }
        }
        
      }
      myFileB.close();
  //test open end
  
      Serial.println("sdlist GO");
    sdlist();
    Serial.println("---------Wait For AnyKeyIn");
  while(Serial.available()==0)
  {
    if(Serial.available()>0)
    {
      Serial.println("GO START");
    }
    
  }
  startime=millis();
  sdflag=0;
  chk=3;//3:LOG無し 2:Writeエラー　１:OPENエラー　０：SD書き込みOK
}
//●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●●
//+++++++++++++++++++LOOP LOOP LOOP LOOP LOOP++++++++++++++++++++++++++++++++++++++++++++++++++++++++
//+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++

void loop() 
{  
   //p1=micros();
  //----------BNOREAD してSD ログ　dN>500以降常時ログ------------------------------------
   bncnt0=bnoread31(dB3,dB1,19,bncnt0);//cnt dB1[19]戻り
   //p1_1=micros();
   //Serial.printf("bnoread time=%d\n\r",p1_1-p1); //bnoread31は1microsecしかかからない
   /*//------DEBUG BNO OUTPUT-------------------
   //Serial.println(bncnt1);    　
      if(dB3[2]!=dB3_1){
          dB3_1=dB3[2];//１個前indexを記憶
          Serial.printf("bnoread31,cnt=%d,",bncnt1);
         
          for(i=0;i<16;i++){
            Serial.printf("%x,",dB3[i]);
          }
      if(dB1[2]!=dB1_1){
                dB1_1=dB1[2];//1個前indexを記憶
                for(i=0;i<16;i++){
                  Serial.printf("%x,",dB1[i]);
                }
                 Serial.printf(",%d msec",millis());
                 Serial.println();
                }
   }
   *///DEBUG END-----------------------------------------------
     // dB1_1=dB1[2];
 
  //uint32_tでカウント
  //Serial.printf("bncnt=%d,bnstr3=%s\n\r",bncnt,bnostr3);
  uint8_t dno[4];//bnocntを4byteに変換
  uint8_t adno1[4];//data1chiを4byteに変換
  uint8_t adno2[4];//data2chiを4byteに変換
  if(fnflag==1 && bncnt0>bncnt0_1){//dN>500で毎回カウンタ更新された場合にSD　Write
     //myFileI = sd.open(fnameI, FILE_WRITE);//タイマーでOPENするので初め５００カウントまでエラー   
            if(!myFileI){//エラーなら記録しない
                //Serial.printf("BNOmyFileI open Error======fnameI=%c,bncnt0=%d\n\r",fnameI,bncnt0);     
                //exit(0);
            }
            else//エラーでないならSD write
            { 
                  //Serial.println("BNO==============myFileI Write Successed=========");
                  //if(endflip==1){//2chが終わったらデータ取得
                  //DEBUG用に角度変換　aa[0],aa[1],index[2],yawL[3],yawH[4],pitchL[5],pitchH[6],rollL[7],rollH[8]  
                  //float   yaw1=(float)(bin2int(dB1[3],dB1[4])*0.01);//Top yaw
                  //float   pitch1=(float)(bin2int(dB1[5],dB1[6])*0.01);//Top pitch
                  //float   roll1=(float)(bin2int(dB1[7],dB1[8])*0.01);//Top roll
                  //Serial.printf("ADS:1ch=%d,2ch=%d,ft2=%d,bncnt0=%d\n\r",data1chi,data2chi,ft2,bncnt0);
                  //Serial.printf("ADS:1ch=%d,2ch=%d,ft2=%d,bncnt0=%d,yaw=%3.2f,pitch=%3.2f,roll=%3.2f\n\r",data1chi,data2chi,ft2,bncnt0,yaw1,pitch1,roll1);
                  //CPLT 
                  //Serial.printf("%d,%d,%3.2f,%3.2f,%3.2f,%d\n\r",data1chi,data2chi,yaw1,pitch1,roll1,bncnt0);
                     //endflip=0;
                  //}
                   i_to_char(bncnt0,dno, 0);//bncntを４バイトのdnoに分解
                   i_to_char(data1chi,adno1, 0);//bncntを４バイトのdnoに分解
                   i_to_char(data2chi,adno2, 0);//bncntを４バイトのdnoに分解
                   
                    Serial.printf("BNO:bncnt0=%d,dno[]=%x,%x,%x,%x\n\r",bncnt0,dno[0],dno[1],dno[2],dno[3]);
                    Serial.printf("ADS1ch:data1chi=%D,dno[]=%x,%x,%x,%x\n\r",data1chi,adno1[0],adno1[1],adno1[2],adno1[3]);
                    Serial.printf("ADS2ch:data2chi=%d,dno[]=%x,%x,%x,%x\n\r",data2chi,adno2[0],adno2[1],adno2[2],adno2[3]);
                     //BNO bnocnt0 4byte write
                     myFileI.write(0xFF);//Serial3のマーク
                     myFileI.write(dno[0]);//bnocntをヘッドに格納
                     myFileI.write(dno[1]);
                     myFileI.write(dno[2]);
                     myFileI.write(dno[3]);
                     //ADS data1chi 4byte wtite
                     myFileI.write(adno1[0]);//data1chiを次に格納
                     myFileI.write(adno1[1]);
                     myFileI.write(adno1[2]);
                     myFileI.write(adno1[3]);
                     //ADS data2chi 4byte wtite
                     myFileI.write(adno2[0]);//data2chiを次に格納
                     myFileI.write(adno2[1]);
                     myFileI.write(adno2[2]);
                     myFileI.write(adno2[3]);
                     
                     //Serial.print("3:");
                      for(i=0;i<19;i++){
                        myFileI.write(dB3[i]);//dB3 Center IMU
                        //Serial.print(dB3[i],HEX);
                      }
                      //Serial.println();
                      //Serial.print("1:");
                      for(i=0;i<19;i++){
                        myFileI.write(dB1[i]);//dB1 Top IMU
                        //Serial.print(dB1[i],HEX);
                      }
                      bncnt0_1=bncnt0;
             }// myFIleI ELSE END
       
     }//BNO 受信　ログ　END
   
   //---------------Base 受信　ログ-----------------------------------------------------
     //delay(50);
     tw0=millis();
     int sa=tw0-tw2;//前回の受信から経過時間
     if(sa>119){//119msec経過していたら受信それまでは受信しない受信は1msec以内で終わる
        dN=basercv();//dBuf3に収納される960byteまで収納
        tw2=millis();//受信時刻記録
      }
      tw1=millis();
      //Base受信データSDログ起動dcountがインクリメントしたら
      if(dcount>300 && dcount>dcount_1){//fnameBがdcount=200で着くまで待つ
        //ts=micros();
        chk=sdwrite(dcount);//chk=0ならOK chk=1,2,3OPEN WRITEエラー
        //te=micros();
        dcount_1=dcount;
      } 
  
       //-----------------受信結果-----------------------------------------------------
       //Serial.println();
       //Serial.printf("RECIEVED,dN=,%d ,toptime=%d,recvtime-rcvtime_1=%d\n\r",dN,toptime,rcvtime-rcvtime_1);
       
        
     
     if( tw1-tp0>1000)
     //if( dN>172 && tw1-tp0>1000)
     //if(tw1-tw2>119)
    {
         tp0=millis();
       

       //###############################ソースデータSORTしてdBUf4P[]に収納######################################################
      for(n=0;n<dN;n++)
      {
        if(dBuf4[n]==0xB5 && dBuf4[n+1]==0x62 && dBuf4[n+2]==0x01 &&dBuf4[n+3]==0x07)
        {
          stPVTN=n;//PVTスタート番号
          if(n==0)
          {
            stPVTN=0;
            Serial.println();
            Serial.printf("-----------NoSort HeaderOK dN=%d stPVTN=%d-------------------\n\r",dN,stPVTN);
            for(i=0;i<dN;i++)
            {
                dBuf4P[i]=dBuf4[i];//後処理用配列dBuf4Pに渡す
                
                //Serial.print(dBuf4P[i],HEX);
               // Serial.print(",");
            }
            
            //Serial.printf("dN=%d,stPVTN=%d,%x,%x,%x,%x",dN,stPVTN,dBuf4[n],dBuf4[+1],dBuf4[n+2],dBuf4[n+3]);
          }
          else
          {
            basesort(dN,stPVTN,dBuf4P,dBuf4);
            //Serial.println();
            //Serial.printf("dN=%d,stPVTN=%d,%x,%x,%x,%x",dN,stPVTN,dBuf4[n],dBuf4[+1],dBuf4[n+2],dBuf4[n+3]);
          }
          
          
        }
      }
      //Serial.printf("dcount=%d,dN=%d,te-ts=%d-------------\n\r",dN,te-ts);
     
       
        
      //###############################メッセージ分類######################################################
      if(dBuf4P[0]!=0xb5)
      {
         Serial.println("SORT ERROT");
      }
      //メッセージ開始位置検索
      //Serial.printf("<<<<<<<<<<dn=%d>>>>>>>>>>>>>>>\n\r",dN);
      
      for(i=0;i<dN;i++)
      {
       dBuf4[i]=0;//使わなくなった受信バッファ配列をゼロリセット
      if(dBuf4P[i]==0xB5 && dBuf4P[i+1]==0x62 && dBuf4P[i+2]==0x01 &&dBuf4P[i+3]==0x07)
        {
          pvtpos=i;
          //Serial.printf("pvtpos=%d,dBuf4P[%d-%d]=%x,%x,%x,%x\n\r",pvtpos,i,i+3,dBuf4P[i],dBuf4P[i+1],dBuf4P[i+2],dBuf4P[i+3]);
        }
        
   
      //RELPOSNED抽出
       if(dBuf4P[i]==0xB5 && dBuf4P[i+1]==0x62 && dBuf4P[i+2]==0x01 &&dBuf4P[i+3]==0x3c)
       {
              relpos=i;
              //Serial.printf("relpos=%d,dBuf4P[%d-%d]=%x,%x,%x,%x\n\r",relpos,i,i+3,dBuf4P[i],dBuf4P[i+1],dBuf4P[i+2],dBuf4P[i+3]);
       }
       
       if(dBuf4P[i]==0xB5 && dBuf4P[i+1]==0x62 && dBuf4P[i+2]==0x01 &&dBuf4P[i+3]==0x35)
       {
              satpos=i;
              //Serial.printf("satpos=%d,dBuf4P[%d-%d]=%x,%x,%x,%x\n\r",satpos,i,i+3,dBuf4P[i],dBuf4P[i+1],dBuf4P[i+2],dBuf4P[i+3]);
        }
        
      
         
      }//for i
      
       //Serial.printf("HeaderPos:dN=%d,pvtpos=%d,satpos=%d,relpos=%d\n\r",dN,pvtpos,satpos,relpos);



       //^^^^^^^^^^^^^^^^^^^^^^NAV-SAT GET^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
       int pvtnum,relpnum,satnum;
       
       
       for(i=0;i<100;i++)//PVT1配列作成
       {
          dBuf4V[i]=dBuf4P[i];
          pvtnum++;
       }
       for(i=relpos;i<dN;i++)//relpos配列作成
       {
          dBuf4R[i-relpos]=dBuf4P[i];
          relpnum++;
       }
       for(i=satpos;i<relpos;i++)//satの最後がRELPOSの開始
       {
            dBuf4S[i-satpos]=dBuf4P[i];
            satnum++;
       }
        //=======NAV-PVTからFname ================
           int pvti=PVTcnv(dBuf4V,pvt); 
           if(fnflag==0 && dcount>200){
              Filename (pvt); //pvt送ってfnameBいれる
              fnflag=1;
           }
         //======================================
          //dBuf4V[27]=flags
          //dBuf4V[29]=numSVRTK
         //dBuf4V[46]=hAcc LL/dBuf4V[47]=hAcc LH/dBuf4V[48]=hAcc HL/dBuf4V[49]=hAcc HH
          flags=dBuf4V[27];
          numSVr=dBuf4V[29];//RTK計算で使っている衛星数SATのnumSVより少ない
          hacc=double(dBuf4V[46]+dBuf4V[47]*256+dBuf4V[48]*256*256+dBuf4V[49]*256*256*256)/100; //m単位
         ///pvtcnv
        
         /*========NAV-SAT  内訳===================
          dBuf4S[0]=0xB5;
          dBuf4S[1]=0x62;
          dBuf4S[2]=0x01;
          dBuf4S[3]=0x35;
          dBuf4S[4]=0x35;//Message Length L
          dBuf4S[5]=0x35;//Message Length H
          dBuf4S[6]=Serial4.read();//itow0
          dBuf4S[7]=Serial4.read();//itow1
          dBuf4S[8]=Serial4.read();//itow2
          dBuf4S[9]=Serial4.read();//itow3
          dBuf4S[10]=Serial4.read();//ver
          dBuf4S[11]=Serial4.read();//numSV
          dBuf4S[12]=Serial4.read();//reserved1
          dBuf4S[13]=Serial4.read();//reserved2
          //SAT  Payloads N x 12 --------------------
          dBuf4S[14]=//GNSS ID
          dBuf4S[15]=//SATELLITE ID　衛星番号　１バイト
          dBuf4S[16]=//CNO Carrier tonoise ratio dBHz　強度１バイト
          dBuf4S[17]=//Elevation 90deg 　仰角１バイト
          dBuf4S[18]=//Azimas 360deg L
          dBuf4S[19]=//Azimzas 360deg H　方位角２バイト
          dBuf4S[20]=//Pseuidorange residuals L
          dBuf4S[21]=//Pseuidorange residuals L
          dBuf4S[22]=//Flags_1Bit /SignalQuality id_3Bit/svUsed_Bit1/Health_2Bit/diffCur_1Bit/Smoothed_1Bit
          dBuf4S[23]=//OrbitSoiurce_3Bit/Ephmeris_1Bit/
          dBuf4S[24]=//
          dBuf4S[25]=//
          //Next Satellite
          dBuf4S[26]=//GNSS ID          
         */
          
          //itowpvt=dBuf4V[6]+dBuf4V[7]*256+dBuf4V[8]*256*256+dBuf4V[9]*256*256*256;
          //itowsat=dBuf4S[6]+dBuf4S[7]*256+dBuf4S[8]*256*256+dBuf4S[9]*256*256*256;
          //itowrelp=dBuf4R[10]+dBuf4R[11]*256+dBuf4R[12]*256*256+dBuf4R[13]*256*256*256;
          //Serial.printf("itowsat=%d,itowrelp=%d,itowpvt=%d\n\r",itowsat,itowrelp,itowpvt);;
          //NAV-SAT解読 [14]から開始[26] [38].....
          int mesLen=dBuf4S[4]+dBuf4S[5]*256;
          int numSV=dBuf4S[11];
          int GNSSID=dBuf4S[14];
          int SATID=dBuf4S[15];
          int CNO=dBuf4S[16];
          
        
          //Serial.printf("===================mesLen=%d,numSV==%d===================\n\r",mesLen,numSV);
           for(n=0;n<numSV;n++)
           {
             int stN=14+n*12;
             
             gnssid[n]=dBuf4S[stN];
             satid[n]=dBuf4S[stN+1];
             cno[n]=dBuf4S[stN+2];
             elevation[n]=dBuf4S[stN+3];
             azimath[n]=dBuf4S[stN+4];dBuf4S[stN+5];
             
             if(cno[n]>=40)
             {
                upper40[n40]=n;
                n40++;
             }
             else if(cno[n]>=50)
             {
                upper50[n50]=n;
                n50++;
             }

             //Serial.printf("%d:gnsid=%d,satid=%d,cno=%d,elev=%d,azimath=%d\n\r",n,gnssid[n],satid[n],cno[n],elevation[n],azimath[n]);
           }
           //SATが全部含まれているセットだけ採用
           int L=numSV*12+14+100+72;
           //if(dN>L && numSV>10){
            Serial.printf("chk=%d,dc=%d,dN=%d,dL=%d,numSV=%d,Upper40=%d.Upper50=%d,numSVr=%d,flags=%d,hacc=%4.3f,bncnt0=%d te-ts=%d,p1-p1_1=%d\n\r",chk,dcount,dN,L,numSV,n40,n50,numSVr,flags,hacc,bncnt0,te-ts,p1-p1_1);
            delay(1);
            //tp1=millis();
            //Serial.printf("tp0=%d,tp1=%d,tp1-tp0=%d,dN=%d,tw0=%d,tw1=%d,tw2=%d\n\r",tp0,tp1,tp1-tp0,dN,tw0,tw1,tw2);
           //}
           n40=0;
           n50=0;
           pvtpos=1;
           satpos=0;
           relpos=0;
         
          //delay(20);
          
    }//if dN>172
   
}
//++++++++++++++++++++++++++++++LOOP END+++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
